// Fix for text tooltip bug on K 4.0.x  9 November, 2007

var gTooltip = null;
var gWindow;
var gWindowWidth;
var gWindowHeight;

function countLines(text)
{
	var n = 0;
	for (var i = 0; i < text.length; i += 1) { if (text[i] == "\n") { n += 1; } }
	return n;
}

function stringWidth(string, fontname, fontstyle, fontsize)
{
	var tmpText = new Text();
	var width;
	tmpText.opacity = 0;
	tmpText.font = fontname;
	//tmpText.style = fontstyle;
	tmpText.size = fontsize;
	tmpText.data = string;
	width = tmpText.width;
	tmpText = null;
	return width;
}

function sizeOf(text, font, size)
{
	var realLength;
	var maxLength = 44;
	var multipier = 1.6;
	var lines = countLines(text);
	if (lines === 0)
	{
		realLength = Math.ceil(multipier*stringWidth(text, font, "", size) / size);
		if (realLength <= maxLength) { return [realLength + 1, 1]; }
	}
	return [maxLength, lines + 1];
}

function makeTooltip(obj)
{
	var text = obj.tooltip;
	var font = "Lucida Grande";
	var size = 11;
	var theSize = sizeOf(text, font, size);
	var txt       = new TextArea();
	txt.hOffset   = obj.hOffset;
	txt.vOffset   = obj.vOffset + (obj.height>>2) + 4;
	txt.columns   = theSize[0];
	txt.lines     = theSize[1];
	txt.color     = "#000000";
	txt.bgColor   = "#F6F7C1";
	txt.opacity   = 255;
	txt.bgOpacity = 255;
	txt.data      = text;
	txt.font      = font;
	txt.size      = size;
	txt.editable  = false;
	txt.scrollbar = false;
	txt.zOrder = 200;
	return txt;
}

function displayTooltip(window, obj)
{
	if (obj.tooltip !== "")
	{
		gWindow = window;
		gWindowWidth  = window.width;
		gWindowHeight = window.height;
		gTooltip = makeTooltip(obj);
		
		window.width  += gTooltip.width;
		window.height += gTooltip.height + 20;
		window.appendChild(gTooltip);
	}
}

function removeTooltip()
{
	if (gTooltip !== null)
	{
		gWindow.removeChild(gTooltip);
		gTooltip = null;
		gWindow.width  = gWindowWidth;
		gWindow.height = gWindowHeight;
	}
}
